
let hplot paper ymin ymax ch rows y = 
  let frows = float_of_int rows
  in let y_to_rowidx yi = int_of_float ((yi-.ymin) /. (ymax -. ymin) *. frows)
  in let loop = fun x y -> 
    let ri = y_to_rowidx y
    in if (ri>=0 && ri<rows)
       then String.set (Array.get paper (y_to_rowidx y)) x ch
       else ()
  in Array.iteri loop y

let hgraph ymin ymax rows y = 
  let cols = Array.length y
  in let paper = Array.init rows (fun _ -> (String.make cols ' '))
  in (hplot paper ymin ymax '_' rows (Array.create cols 0.0);
      hplot paper ymin ymax '.' rows y;
      Array.iteri (fun i _ -> Printf.printf "%s\n" paper.(rows-1-i)) paper
     )

let hgraph1  = hgraph (-1.0) 1.001
let hgraph01 = hgraph   0.0  1.001
